--[[
#########################################################################################
# THE TETRAMINOE GENERATOR SINGLETON CLASS - handles tetraminoe generation during game	#
#########################################################################################
--]]

cGenerator = {}

-- define some vars
-- 1. Generator style being used
cGenerator.style = 3 -- default

-- 2. Vars used for 'bag' generator
cGenerator.sequence = {1, 2, 3, 4, 5, 6, 7}
cGenerator.element = 1

-- 3. Vars used for TGM generator
cGenerator.history = {6, 7, 6, 7}
cGenerator.nTries = 4
-- 4. Vars used for bastard generator
-- none

-- THIS FUNCTION generate a "nextpiece" ID according to the generator selected by the user
function cGenerator:getNewPiece()

	if self.style == 1 then
		-- simple random generator
		-- return next piece
		return math.random(1,7)
		
	elseif self.style == 2 then
		-- bag generator
		local f = self.sequence[self.element] -- save value to return
		self.element = (self.element % #self.sequence) + 1 -- calculate next element
		-- if next element is 1, then reshuffle the sequence
		if self.element == 1 then shuffle(self.sequence) end
		-- return next piece
		return f
		
	elseif self.style == 3 then
		-- TGM generator
		local n = 0
		for i = 1, self.nTries do -- try "self.nTries" times to randomize a piece different than the previous 4
			n = math.random(1,7) -- randomize a piece
			if ((n ~= self.history[1]) and (n ~= self.history[2])
			and (n ~= self.history[3]) and (n ~= self.history[4])) then break end -- if not equal to previous 4, stop trying
		end
		-- update history
		for j = 1, #self.history - 1 do
			self.history[j] = self.history[j+1]
		end
		self.history[#self.history] = n
		-- return next piece
		return n
		
	elseif self.style == 4 then
		-- bastard generator >> just gives preference to pieces in this order Z & S > T > O > J & L > I
		-- array order: "O, I, L, J, T, Z, S"
		local t = math.random(1,100)
		if t >= 50 then return math.random (6,7)
		elseif t>= 30 then return 5
		elseif t>= 20 then return 1
		elseif t>= 12 then return 4
		elseif t>= 4 then return 3
		elseif t>= 1 then return 2 end
	end
	
end