--[[
#########################################################################################
# THE DATA SAVING SINGLETON CLASS - handles reading and writing data to file			#
#########################################################################################
--]]

cOptions = {}


-- Creates a new file and fill it with the standart options
function cOptions:save(filename)
	-- create file
	local file=love.filesystem.newFile(filename)
	-- open file
	file:open("w")
	-- save the control keys
	for a = 1, #PcontrolMap do
		file:write(PcontrolMap[a] .. "\n")
	end
	-- save gameplay options
	file:write(blindmode .. "\n")
	file:write(boardSize .. "\n")
	file:write(tetraGen .. "\n")
	file:write(fullscreen .. "\n")
	-- close file
	file:close()
end


-- Loads the options from file
function cOptions:load(filename)
	-- load file
	local file=love.filesystem.newFile(filename)
	-- open file
	file:open("r")
	
	local a = 1
	-- save contents
	for line in file:lines() do
		if a <= #PcontrolMap then
			-- first save the control keys
			PcontrolMap[a] = line
		else
			-- next save gameplay options:
			-- 1. blindmode
			if a == #PcontrolMap + 1 then blindmode = tonumber(line) end
			-- 2. board dimensions
			if a == #PcontrolMap + 2 then
				-- save
				boardSize = tonumber(line)
				-- set board dimensions
				if boardSize == 1 then
					bW = 10
					bH = 20
				elseif boardSize == 2 then
					bW = 20
					bH = 20
				elseif boardSize == 3 then
					bW = 20
					bH = 10
				end	
			end
			-- 3. tetraminoe generator
			if a == #PcontrolMap + 3 then
				tetraGen = tonumber(line)
				cGenerator.style = tetraGen
			end
			-- 4. fullscreen Y/N
			if a == #PcontrolMap + 4 then
				fullscreen = tonumber(line)
				-- modify screen mode
				if fullscreen == 1 then
					if love.graphics.checkMode(800, 600, true) then love.graphics.setMode(800, 600, true) end
				end
			end
			
		end
		a = a + 1
	end
	-- close file
	file:close()
end
