--[[
#########################################################################################
# THE BUTTON CLASS - handles buttons													#
#########################################################################################
--]]

cButton = {}
cButton.__index = cButton

-- THIS FUNCTION CREATES A BUTTON TABLE
function cButton.create(text, x, y, font, offColor, onColor)
	
	local temp = {}
	setmetatable(temp, cButton)
	
								-- SAVE SOME PROPERTIES
	temp.text = text			-- The text in the button
	temp.x = x					-- X pos
	temp.y = y					-- Y pos
	temp.font = font			-- The font used for this button
	temp.offColor = offColor	-- The text color while not active >> its a reference to a global table called color
	temp.onColor = onColor		-- The text color while active >> its a reference to a global table called color
	temp.hover = false 			-- If button is active or not

	return temp
	
end


-- THIS FUNCTION DRAWS THE BUTTON
function cButton:draw()

	-- 1. set font
	love.graphics.setFont(font[self.font])
	-- 2. set color based on state
	if self.hover then
		love.graphics.setColor(color[self.onColor])
	else
		love.graphics.setColor(color[self.offColor])
	end
	-- 3. draw button label based on button type
	if self.text == " " then love.graphics.print("space", self.x, self.y)
	else love.graphics.print(self.text, self.x, self.y) end -- draw the text
	
end