--[[
#########################################################################################
# THE TEX BOX CLASS - handles a simple text box											#
#########################################################################################
--]]

cText = {}
cText.__index = cText

-- THIS FUNCTION CREATES A BUTTON TABLE
function cText.create(text, x, y, max, font, color)
	
	local temp = {}
	setmetatable(temp, cText)
	
								-- SAVE SOME PROPERTIES
	temp.text = text			-- The various labels in the button
	temp.x = x					-- X pos
	temp.y = y					-- Y pos
	temp.max = max				-- max number of chars that can be displayed
	temp.font = font			-- The font used for this button
	temp.color = color			-- The text color
	--temp.cursorpos

	return temp
	
end


-- THIS FUNCTION DRAWS THE TEXT BOX
function cText:draw()

	-- 1. set font
	love.graphics.setFont(font[self.font])
	-- 2. set color
	love.graphics.setColor(color[self.color])
	-- 3. draw text
	love.graphics.print(self.text, self.x, self.y)
	-- 4. draw cursor
	love.graphics.setColor(color["foreground"])
	love.graphics.print("|", self.x + font[self.font]:getWidth(self.text), self.y)

end


function cText:keypressed(key, unicode)
	-- first check if user wants to delete a character
	if key == "backspace" then
		-- delete it
		self.text = string.sub(self.text, 1, -2)
	else
		-- only care about letters
		if ((unicode >= 48 and unicode <= 57) or (unicode >= 65 and unicode <= 90) or (unicode == 95) or (unicode >= 97 and unicode <= 122)) then
		-- we can only add more characters if the textbox isn't full
			if (string.len(self.text) < self.max) then
				--self.text = self.text .. tostring(key)
				self.text = self.text .. string.char(unicode)
			end
		end	
	end
end
