--[[
#########################################################################################
# THE HIGHSCORES MENU - handles the highscores menu state								#
#########################################################################################
--]]

sMenuHighscores = {}
sMenuHighscores.__index = sMenuHighscores


--cButton.create(text, x, y, font, offColor, onColor, combo)


-- THIS FUNCTION CREATES A TABLE with the main menu in it
function sMenuHighscores.create()
	
	local temp = {} -- first create a temp table
	setmetatable(temp, sMenuHighscores) -- make its metatable this very own
	
	-- create the buttons it holds
	temp.button = {}
	temp.button[1] = cButton.create("Back", (love.graphics.getWidth() / 4) - (font["menu"]:getWidth("<Restart>") / 2), love.graphics.getHeight() - 80, "menu", 2, "foreground")
	
	temp.active = 1
	temp.button[temp.active].hover = true

	return temp
	
end


-- THIS FUNCTION DRAWS THE MAIN MENU
function sMenuHighscores:draw()

	-- 1. draw a logo
	drawLogo (40, "title")
	
	-- 2. draw the highscores table
		-- 2.1 the title
		love.graphics.setFont(font["smalltitle"]) -- set font
		love.graphics.setColor(color["dark"]) -- set color
		love.graphics.print("- Single Player Highscores -", (love.graphics.getWidth() / 2) - (font["smalltitle"]:getWidth("- Single Player Highscores -") / 2), 133)		
		love.graphics.setColor(color["foreground"]) -- set color
		love.graphics.print("- Single Player Highscores -", (love.graphics.getWidth() / 2) - (font["smalltitle"]:getWidth("- Single Player Highscores -") / 2), 130)		
		-- 2.2 draw scores table
		love.graphics.setColor(0,0,0,50)
		love.graphics.rectangle("fill", 40, 170, love.graphics.getWidth() - 80, love.graphics.getHeight() - 200)
		love.graphics.setColor(color["dark"])
		love.graphics.rectangle("line", 40, 170, love.graphics.getWidth() - 80, love.graphics.getHeight() - 200)
		love.graphics.setFont(font["medium"]) -- set font
		love.graphics.setColor(color[6]) -- set color
		-- 2.2.1 draw position
		love.graphics.print("Place", 100, 180)		
		-- 2.2.2 draw score
		love.graphics.print("Score", 250, 180)	
		-- 2.2.3 draw name
		love.graphics.print("Name", 400, 180)
		-- 2.2.4 draw every score	
		for i = 1, cHighscores.places do
			-- draw position
			love.graphics.setColor(color[4]) -- set color
			love.graphics.print("\t>> " .. i , 100, 180 + i*30)		
			-- draw score
			love.graphics.setColor(color[3]) -- set color
			love.graphics.print(cHighscores.score[i] , 250, 180 + i*30)	
			-- draw name
			love.graphics.setColor(color[7]) -- set color
			love.graphics.print(cHighscores.name[i] , 400, 180 + i*30)
		end

	-- 3. draw button
	self.button[1]:draw()


end


-- THIS FUNCTION UPDATES THE MAIN MENU (nothing here)
function sMenuHighscores:update()
	
end


-- THIS FUNCTION IS CALLED WHEN A KEY IS PRESSED, and handles it
function sMenuHighscores:keypressed(key)

	if (key == "return" or key == "escape") then	
		-- button pressed
		state = sMenuMain.create()
	end
	
end