--[[
#########################################################################################
# CONTAINS MISC FUNCTIONS																#
#########################################################################################
--]]

-- THIS FUNCTIONS DRAWS A CENTERED "LOVELY TETRIS" LOGO
function drawLogo (y, f)

	-- draw shadow
	--love.graphics.setFont(font["title2"])
	--love.graphics.setColor(color["dark"])
	--love.graphics.print("LOVELY TETRIS", ((love.graphics.getWidth() / 2) - (font["title2"]:getWidth("LOVELY TETRIS") / 2)), y)
	local dist = 3
	local titlePosX = ((love.graphics.getWidth() / 2) - (font[f]:getWidth("LOVELY TETRIS") / 2))
	
	-- 1. set font
	love.graphics.setFont(font[f])
	-- 2. draw the title
	love.graphics.setColor(color["dark"])
	love.graphics.print("L", titlePosX, y+dist)
	love.graphics.setColor(color[1])
	love.graphics.print("L", titlePosX, y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("O", titlePosX + font[f]:getWidth("L"), y+dist)
	love.graphics.setColor(color[3])
	love.graphics.print("O", titlePosX + font[f]:getWidth("L"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("V", titlePosX + font[f]:getWidth("LO"), y+dist)
	love.graphics.setColor(color[4])
	love.graphics.print("V", titlePosX + font[f]:getWidth("LO"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("E", titlePosX + font[f]:getWidth("LOV"), y+dist)
	love.graphics.setColor(color[5])
	love.graphics.print("E", titlePosX + font[f]:getWidth("LOV"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("L", titlePosX + font[f]:getWidth("LOVE"), y+dist)
	love.graphics.setColor(color[6])
	love.graphics.print("L", titlePosX + font[f]:getWidth("LOVE"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("Y", titlePosX + font[f]:getWidth("LOVEL"), y+dist)
	love.graphics.setColor(color[7])
	love.graphics.print("Y", titlePosX + font[f]:getWidth("LOVEL"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("T", titlePosX + font[f]:getWidth("LOVELY "), y+dist)
	love.graphics.setColor(color[7])
	love.graphics.print("T", titlePosX + font[f]:getWidth("LOVELY "), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("E", titlePosX + font[f]:getWidth("LOVELY T"), y+dist)
	love.graphics.setColor(color[6])
	love.graphics.print("E", titlePosX + font[f]:getWidth("LOVELY T"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("T", titlePosX + font[f]:getWidth("LOVELY TE"), y+dist)
	love.graphics.setColor(color[5])
	love.graphics.print("T", titlePosX + font[f]:getWidth("LOVELY TE"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("R", titlePosX + font[f]:getWidth("LOVELY TET"), y+dist)
	love.graphics.setColor(color[4])
	love.graphics.print("R", titlePosX + font[f]:getWidth("LOVELY TET"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("I", titlePosX + font[f]:getWidth("LOVELY TETR"), y+dist)
	love.graphics.setColor(color[3])
	love.graphics.print("I", titlePosX + font[f]:getWidth("LOVELY TETR"), y)
	love.graphics.setColor(color["dark"])
	love.graphics.print("S", titlePosX + font[f]:getWidth("LOVELY TETRI"), y+dist)
	love.graphics.setColor(color[1])
	love.graphics.print("S", titlePosX + font[f]:getWidth("LOVELY TETRI"), y)
	
	-- 3. draw a credit notice
	love.graphics.setFont(font["micro"])
	love.graphics.setColor(color["dark"])
	love.graphics.print("tv_user @ 2012", ((love.graphics.getWidth() / 2) - (font["micro"]:getWidth("tv_user @ 2012") / 2)), (love.graphics.getHeight() - (2 * font["micro"]:getHeight()) + dist/2))
	love.graphics.setColor(color["foreground"])
	love.graphics.print("tv_user @ 2012", ((love.graphics.getWidth() / 2) - (font["micro"]:getWidth("tv_user @ 2012") / 2)), (love.graphics.getHeight() - (2 * font["micro"]:getHeight())))
end


-- THIS FUNCTIONS DRAWS A CENTERED "GAME OVER" SPLASH
function drawGameOver (f1, f2)
	-- 1. game over splash
	love.graphics.setFont(font[f1]) -- set font
	love.graphics.setColor(color["dark"]) -- set color
	love.graphics.print("GAME OVER", (love.graphics.getWidth() / 2) - (font[f1]:getWidth("GAME OVER") / 2), (love.graphics.getHeight() / 2) + 2)
	love.graphics.setColor(color[7]) -- set color
	love.graphics.print("GAME OVER", (love.graphics.getWidth() / 2) - (font[f1]:getWidth("GAME OVER") / 2), (love.graphics.getHeight() / 2))
	-- 2. instructions splash
	love.graphics.setFont(font[f2]) -- set font
	love.graphics.setColor(color["dark"]) -- set color
	love.graphics.print("Press '" .. PcontrolMap[6] .. "' to restart", (love.graphics.getWidth() / 2) - (font[f2]:getWidth("Press '" .. PcontrolMap[6] .. "' to restart") / 2), (love.graphics.getHeight() / 2) + 92)		
	love.graphics.print("or '".. PcontrolMap[7] .. "' to quit", (love.graphics.getWidth() / 2) - (font[f2]:getWidth("or '".. PcontrolMap[7] .. "' to quit") / 2), (love.graphics.getHeight() / 2) + 122)		
	love.graphics.setColor(color[6]) -- set color
	love.graphics.print("Press '" .. PcontrolMap[6] .. "' to restart", (love.graphics.getWidth() / 2) - (font[f2]:getWidth("Press '" .. PcontrolMap[6] .. "' to restart") / 2), (love.graphics.getHeight() / 2) + 90)		
	love.graphics.setColor(color[3]) -- set color
	love.graphics.print("or '".. PcontrolMap[7] .. "' to quit", (love.graphics.getWidth() / 2) - (font[f2]:getWidth("or '".. PcontrolMap[7] .. "' to quit") / 2), (love.graphics.getHeight() / 2) + 120)		
end


-- THIS FUNCTIONS DRAWS A CENTERED "VICTORY" SPLASH
function drawVictory (f1, f2)
	-- 1. victory splash
	love.graphics.setFont(font[f1]) -- set font
	love.graphics.setColor(color["dark"]) -- set color
	love.graphics.print("OMG YOU WON!!", (love.graphics.getWidth() / 2) - (font[f1]:getWidth("OMG YOU WON!!") / 2), (love.graphics.getHeight() / 2) + 2)
	love.graphics.setColor(color[7]) -- set color
	love.graphics.print("OMG YOU WON!!", (love.graphics.getWidth() / 2) - (font[f1]:getWidth("OMG YOU WON!!") / 2), (love.graphics.getHeight() / 2))
	-- 2. instructions splash
	love.graphics.setFont(font[f2]) -- set font
	love.graphics.setColor(color["dark"]) -- set color
	love.graphics.print("Press '" .. PcontrolMap[6] .. "' to restart", (love.graphics.getWidth() / 2) - (font[f2]:getWidth("Press '" .. PcontrolMap[6] .. "' to restart") / 2), (love.graphics.getHeight() / 2) + 92)		
	love.graphics.print("or '".. PcontrolMap[7] .. "' to quit", (love.graphics.getWidth() / 2) - (font[f2]:getWidth("or '".. PcontrolMap[7] .. "' to quit") / 2), (love.graphics.getHeight() / 2) + 122)		
	love.graphics.setColor(color[6]) -- set color
	love.graphics.print("Press '" .. PcontrolMap[6] .. "' to restart", (love.graphics.getWidth() / 2) - (font[f2]:getWidth("Press '" .. PcontrolMap[6] .. "' to restart") / 2), (love.graphics.getHeight() / 2) + 90)		
	love.graphics.setColor(color[3]) -- set color
	love.graphics.print("or '".. PcontrolMap[7] .. "' to quit", (love.graphics.getWidth() / 2) - (font[f2]:getWidth("or '".. PcontrolMap[7] .. "' to quit") / 2), (love.graphics.getHeight() / 2) + 120)		
end


-- SHUFFLES AN ARRAY
function shuffle(tab)
  local len = #tab
  local r
  for i = 1, len do
    r = math.random(i, len)
    tab[i], tab[r] = tab[r], tab[i]
  end
end