--[[
#########################################################################################
# CONTAINS GLOBAL VARIABLES																#
#########################################################################################
--]]
	
-- 1. COLORS
	color =	 {	{22,147,165,255}, 	-- 1
				{173,216,199,255},	-- 2
				{209,242,165,255},	-- 3
				{239,250,180,255}, 	-- 4
				{255,196,140,255},	-- 5
				{255,159,128,255},	-- 6
				{245,105,145,255}, 	-- 7
				background 	= {85,98,112,255},
				darkback	= {60,73,85,255},
				foreground	= {250,250,250,255},
				dark 		= {42,48,54,255},
				highlight	= {245,105,145,255},
				grey		= {51,51,51,255}	}
				

---[[ 2. FONTS
	font = {	menu = love.graphics.newFont("font/Eight One.ttf", 40),
				medium = love.graphics.newFont("font/Eight One.ttf", 30),
				default = love.graphics.newFont("font/Eight One.ttf", 20),
				title = love.graphics.newFont("font/DELTA.ttf", 100),
				title2 = love.graphics.newFont("font/DELTA.ttf", 80),
				smalltitle = love.graphics.newFont("font/DELTA.ttf", 40),
				micro = love.graphics.newFont("font/Eight One.ttf", 13)	}
--]]
-- 3. PLAYER CONTROL MAP - default values
	-- the control map is overwritten when loading from file (in main.lua)

	PcontrolMap = { "left",		-- P1 left
					"right",	-- P1 right
					" ",		-- P1 rotate
					"down",		-- P1 down
					"p",		-- Pause
					"r",		-- Restart
					"escape",	-- Quit
					"a",		-- P2 left
					"d",		-- P2 right
					"w",		-- P2 rotate
					"s" }		-- P2 down

-- 4. GAMEPLAY OPTIONS - default values
	-- these vars are overwritten when loading options from file (in main.lua)
	-- blindmode
	blindmode = 2 					-- 1 = on, 2 = off
	-- board size
	boardSize = 1					-- 1 = 10*20, 2 = 20*20, 3 = 20*10
	-- Tetraminoe generator
	tetraGen = 3					-- 1 = random, 2 = bag, 3 = TGM, 4 = bastard
	-- Fullscreen on/off
	fullscreen = 2					-- 1 = on, 2 = off

-- 5. GAME VARS
	bH = 20					-- board height
	bW = 10					-- board width
	nPBlocks = 5			-- num of blocks V/H in each piece array > always 5
	blockSize = 16			-- size of the blocks
	INIT_WAIT_TIME = 800	-- time to drop the piece one space down

-- 6. CANVAS
	canvas = love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())

--[[
	music =	{	main = love.audio.newSource("media/main.ogg") }
	
	
	sound =	{	move = love.audio.newSource("media/move.wav"),
				rotate = love.audio.newSource("media/rotate.wav"),
				store = love.audio.newSource("media/store.wav"),
				line = love.audio.newSource("media/line.wav") }
				

	graphics = {logo = love.graphics.newImage("media/logo.png"),
				fmas = love.graphics.newImage("media/fmas.png"),
				set = love.graphics.newImage("media/set.png"),
				notset = love.graphics.newImage("media/notset.png") }
--]]